// JavaScript Document
function Cgame(gameDivId){
	var game=this;
	this.gameDiv=document.getElementById(gameDivId);
	this.clientWidth=this.clientHeight=0;
	this.homeURL=homeURL+'js/games/race/';
	this.time=0;this.frameTime=0;
	this.config=false;
	this.UI=false;
	this.SFX=false;
	this.assets=false;
	
	this.player=false;
	this.loadingStage=0;
	this.config=false;
	
	this.gameType=false;//single or multi
	this.cars=false;//array of players in the current race
	this.trackPan=0;//camera position on the track
	this.trackPos=0;//track position - to make it move around all race
	this.endPos=0;//track position at the end of the race
	this.trackLength=0;
	this.raceTime=0;
	this.difficulty=0;
	this.sentence='';
	this.sentences=null;
	this.currentLetter=0;
	this.finished=false;
	this.DrawInterval=null;
	this.language;
		var GET=getSearchParameters();
		var lang=GET.lang;if(!lang)lang=GET.language;if(!lang)lang='en';
		lang=lang.split("_");
		this.language=lang[0].toLowerCase();
	this.soundOn=true;
	
	this.hints=0;
	this.hintStart=0;

	this.Load=Load;function Load(forceResize){
		if(this.DrawInterval)clearInterval(this.DrawInterval);
		this.DrawInterval=setInterval(RunMain,30);
		this.UI=new Cui(this);
		this.SFX=new CcarSFX(this);
		if(this.gameDiv){
			if(!this.gameDiv.style.background){this.gameDiv.style.background='#ffffff url("'+this.homeURL+'assets/images/bg_01.png") no-repeat center top';this.gameDiv.style.backgroundSize='contain';};
			cw=this.gameDiv.clientWidth;ch=this.gameDiv.clientHeight;
			if(cw/ch>960/640)cw=ch*960/640;else ch=cw*640/960;
			if(this.clientWidth!=cw || this.clientHeight!=ch || forceResize){
				this.Resize(cw,ch);
			}
		}

		this.assets=new resourcesManager(this);
		if(!configURL || configURL=='')configURL=this.homeURL+'config/config.json';
		this.assets.LoadFile('config',configURL);
		this.assets.LoadImage('LoadingBar',this.homeURL+'assets/images/Loading_bar1.png');
		this.assets.LoadImage('LoadingFrame',this.homeURL+'assets/images/Loading_fame.png');
		this.assets.Start(this.startLoad,this);
	}
	
	this.Resize=Resize;function Resize(Pwidth,Pheight){//960x640
		this.clientWidth=Pwidth;
		this.clientHeight=Pheight;
		var obj=document.getElementById('UIContainer');
		if(obj){
			obj.style.width=Pwidth+'px';
			obj.style.height=Pheight+'px';
		}
		if(this.UI){
			this.UI.scaleVal=Pwidth/960;
			this.UI.status=false;
			this.UI.hidePopup();
			this.UI.drawLoading(true);
		}
	}
	
	this.startLoad=startLoad;function startLoad(){
		this.config=JSON.parse(this.assets.Data.Files.config);
		startGSP(14,this);
		//preloading the font
		this.assets.LoadFile('font',this.homeURL+'assets/font/airstrikecond.ttf');
		//preloading button components
		//tab
		this.assets.LoadImage('middletab',this.homeURL+'assets/images/buttons/middletab.png');
		this.assets.LoadImage('middletabOn',this.homeURL+'assets/images/buttons/middletabOn.png');
		//65
		this.assets.LoadImage('middle65',this.homeURL+'assets/images/buttons/middle65.png');
		this.assets.LoadImage('middle65On',this.homeURL+'assets/images/buttons/middle65On.png');
		this.assets.LoadImage('margin65',this.homeURL+'assets/images/buttons/margin65.png');
		this.assets.LoadImage('margin65On',this.homeURL+'assets/images/buttons/margin65On.png');
		//52
		this.assets.LoadImage('middle52',this.homeURL+'assets/images/buttons/middle52.png');
		this.assets.LoadImage('middle52On',this.homeURL+'assets/images/buttons/middle52On.png');
		this.assets.LoadImage('margin52',this.homeURL+'assets/images/buttons/margin52.png');
		this.assets.LoadImage('margin52On',this.homeURL+'assets/images/buttons/margin52On.png');
		//64
		this.assets.LoadImage('middle64',this.homeURL+'assets/images/buttons/middle64.png');
		this.assets.LoadImage('middle64On',this.homeURL+'assets/images/buttons/middle64On.png');
		this.assets.LoadImage('margin64',this.homeURL+'assets/images/buttons/margin64.png');
		this.assets.LoadImage('margin64On',this.homeURL+'assets/images/buttons/margin64On.png');
		
		this.assets.LoadImage('LoginBackground',this.homeURL+'assets/images/translate/'+this.language+'/bg_02.png');

		this.assets.LoadImage('flag',this.homeURL+'assets/images/translate/'+this.language+'/flag.png');
		this.assets.LoadImage('PopupBg',this.homeURL+'assets/images/popupBG.png');
		this.assets.LoadImage('MainMenuBg',this.homeURL+'assets/images/MenuBG-59.png');
		this.assets.LoadImage('EmptyButton',this.homeURL+'assets/images/empty-off.png');
		this.assets.LoadImage('EmptyButtonH',this.homeURL+'assets/images/empty-on.png');
		this.assets.LoadImage('soundOFF',this.homeURL+'assets/images/soundOFF.png');
		this.assets.LoadImage('soundON',this.homeURL+'assets/images/soundON.png');
		this.assets.LoadImage('HighScoresButton',this.homeURL+'assets/images/highscore.png');
		this.assets.LoadImage('HighScoresButtonH',this.homeURL+'assets/images/highscore-chosen.png');
		this.assets.LoadImage('GarrageButton',this.homeURL+'assets/images/translate/'+this.language+'/Garage_n.png');
		this.assets.LoadImage('GarrageButtonH',this.homeURL+'assets/images/translate/'+this.language+'/Garage_a.png');
		this.assets.LoadImage('garrageButton',this.homeURL+'assets/images/Garage.png');
		this.assets.LoadImage('garrageButtonH',this.homeURL+'assets/images/GarageSEL.png');
		this.assets.LoadImage('soloButton',this.homeURL+'assets/images/solo.png');
		this.assets.LoadImage('soloButtonH',this.homeURL+'assets/images/SoloSEL.png');
		this.assets.LoadImage('multiButton',this.homeURL+'assets/images/Multi.png');
		this.assets.LoadImage('multiButtonH',this.homeURL+'assets/images/MultiSEL.png');
		this.assets.LoadImage('ActionBar',this.homeURL+'assets/images/Action_bar.png');
		
		this.assets.LoadImage('facebook',this.homeURL+'assets/images/providers/facebook.png');
		this.assets.LoadImage('facebookH',this.homeURL+'assets/images/providers/facebookON.png');
		this.assets.LoadImage('twitter',this.homeURL+'assets/images/providers/twitter.png');
		this.assets.LoadImage('twitterH',this.homeURL+'assets/images/providers/twitterON.png');
		
		for(i=0;i<this.config.gameSettings.language.list.length;i++){
			this.assets.LoadImage('flag_'+i,this.homeURL+'assets/images/translate/'+this.config.gameSettings.language.list[i].folder+'/flag.png');
		}

		for(i=0;i<this.config.gameSettings.cars.length;i++){
			for(j=0;j<this.config.gameSettings.cars[i].images.length;j++){
				this.assets.LoadImage('carImg_'+i+'_'+j,this.homeURL+'assets/images/'+this.config.gameSettings.cars[i].images[j]);
			}
		}

		this.assets.Start(this.LoadConfig,this);
	}
	
	this.LoadConfig=LoadConfig;function LoadConfig(){
		this.loadingStage=1;
		this.status='main menu';
		if(this.UI){
			this.UI.status=false;
			this.UI.hidePopup();
			this.UI.drawLoading(true);
		}
	}
	
	this.LoadGameData=LoadGameData;function LoadGameData(){
		this.assets.LoadFile('typingSentence',this.config.gameSettings.difficulty[this.difficulty].elementsUrl);
		
		if(this.loadingStage>=2){
			this.assets.Start(this.LoadedGameData,this);
			return;
		}
		var i,j;
		
		this.assets.LoadImage('raceBG',this.homeURL+'assets/images/race/RaceBG.png');
		this.assets.LoadImage('Start',this.homeURL+'assets/images/race/Start.png');
		this.assets.LoadImage('Finish',this.homeURL+'assets/images/race/Finish.png');
		this.assets.LoadImage('RedLight',this.homeURL+'assets/images/race/redlight.png');
		this.assets.LoadImage('YellowLight',this.homeURL+'assets/images/race/yellowLight.png');
		this.assets.LoadImage('GreenLight',this.homeURL+'assets/images/race/greenlight.png');
		this.assets.LoadImage('TypingFrame',this.homeURL+'assets/images/race/Typing_Frame.png');
		this.assets.LoadImage('WPMclock',this.homeURL+'assets/images/race/WPNclock.png');
		this.assets.LoadImage('WPMdial',this.homeURL+'assets/images/race/WPNdial.png');
		this.assets.LoadImage('ErrorClock',this.homeURL+'assets/images/race/ErrorClock.png');
		this.assets.LoadImage('ErrorDial',this.homeURL+'assets/images/race/ErrorDial.png');
		this.assets.LoadImage('ACC',this.homeURL+'assets/images/race/ACC.png');
		this.assets.LoadImage('Time',this.homeURL+'assets/images/race/Time.png');
		this.assets.LoadImage('HintBG',this.homeURL+'assets/images/race/hintLeftBG.png');
		this.assets.LoadImage('hintIcon',this.homeURL+'assets/images/race/hintLeftIcon.png');
		this.assets.LoadImage('replay',this.homeURL+'assets/images/race/replay.png');
		this.assets.LoadImage('hintButton',this.homeURL+'assets/images/race/HintBTN-BG.png');

		this.assets.LoadImage('emptyBG',this.homeURL+'assets/images/bg_03.png');

		this.assets.LoadImage('smoke_1_1',this.homeURL+'assets/images/sfx/CarSmoke_01_1.png');
		this.assets.LoadImage('smoke_1_2',this.homeURL+'assets/images/sfx/CarSmoke_01_2.png');
		this.assets.LoadImage('smoke_1_3',this.homeURL+'assets/images/sfx/CarSmoke_01_3.png');
		this.assets.LoadImage('smoke_1_4',this.homeURL+'assets/images/sfx/CarSmoke_01_4.png');
		this.assets.LoadImage('smoke_2_1',this.homeURL+'assets/images/sfx/CarSmoke_02_1.png');
		this.assets.LoadImage('smoke_2_2',this.homeURL+'assets/images/sfx/CarSmoke_02_2.png');
		this.assets.LoadImage('smoke_2_3',this.homeURL+'assets/images/sfx/CarSmoke_02_3.png');
		this.assets.LoadImage('smoke_2_4',this.homeURL+'assets/images/sfx/CarSmoke_02_4.png');
		this.assets.LoadImage('smoke_2_5',this.homeURL+'assets/images/sfx/CarSmoke_02_5.png');
		this.assets.LoadImage('smoke_2_6',this.homeURL+'assets/images/sfx/CarSmoke_02_6.png');
		this.assets.LoadImage('fire_1_1',this.homeURL+'assets/images/sfx/fire_01_1.png');
		this.assets.LoadImage('fire_1_2',this.homeURL+'assets/images/sfx/fire_01_2.png');
		this.assets.LoadImage('fire_1_3',this.homeURL+'assets/images/sfx/fire_01_3.png');
		this.assets.LoadImage('fire_1_4',this.homeURL+'assets/images/sfx/fire_01_4.png');
		this.assets.LoadImage('fire_2_1',this.homeURL+'assets/images/sfx/fire_02_1.png');
		this.assets.LoadImage('fire_2_2',this.homeURL+'assets/images/sfx/fire_02_2.png');
		this.assets.LoadImage('fire_2_3',this.homeURL+'assets/images/sfx/fire_02_3.png');
		this.assets.LoadImage('fire_2_4',this.homeURL+'assets/images/sfx/fire_02_4.png');
		this.assets.LoadImage('tires_1',this.homeURL+'assets/images/sfx/TireTracks_1.png');
		this.assets.LoadImage('tires_2',this.homeURL+'assets/images/sfx/TireTracks_2.png');
		this.assets.LoadImage('tires_3',this.homeURL+'assets/images/sfx/TireTracks_3.png');
		this.assets.LoadImage('tires_4',this.homeURL+'assets/images/sfx/TireTracks_4.png');

		if(this.config.sound_Effects.RaceMusic)
			this.assets.LoadSound('raceMusic',this.homeURL+'assets/sounds/'+this.config.sound_Effects.RaceMusic.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.RaceMusic.audio_ogg);
		if(this.config.sound_Effects.RedLight)
			this.assets.LoadSound('RedLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.RedLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.RedLight.audio_ogg);
		if(this.config.sound_Effects.YellowLight)
			this.assets.LoadSound('YellowLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.YellowLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.YellowLight.audio_ogg);
		if(this.config.sound_Effects.GreenLight)
			this.assets.LoadSound('GreenLight',this.homeURL+'assets/sounds/'+this.config.sound_Effects.GreenLight.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.GreenLight.audio_ogg);
		if(this.config.sound_Effects.typo)
			this.assets.LoadSound('typo',this.homeURL+'assets/sounds/'+this.config.sound_Effects.typo.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.typo.audio_ogg);
		if(this.config.sound_Effects.engine1)
			this.assets.LoadSound('engine1',this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine1.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine1.audio_ogg);
		if(this.config.sound_Effects.engine2)
			this.assets.LoadSound('engine2',this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine2.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.engine2.audio_ogg);
		if(this.config.sound_Effects.crash)
			this.assets.LoadSound('crash',this.homeURL+'assets/sounds/'+this.config.sound_Effects.crash.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.crash.audio_ogg);
		if(this.config.sound_Effects.cheer)
			this.assets.LoadSound('cheer',this.homeURL+'assets/sounds/'+this.config.sound_Effects.cheer.audio_mp3,this.homeURL+'assets/sounds/'+this.config.sound_Effects.cheer.audio_ogg);
		
		this.assets.Start(this.LoadedGameData,this);
	}
	
	this.LoadedGameData=LoadedGameData;function LoadedGameData(){
		var elements=JSON.parse(this.assets.Data.Files.typingSentence);
		var i,j,element;
		this.sentences=new Array();
		this.sentence='';
		this.currentLetter=0;
		this.currentSentence=0;
		this.sentenceAudio=false;
		this.hints=this.config.gameSettings.difficulty[this.difficulty].hintCount;
		for(i=0;i<this.config.gameSettings.difficulty[this.difficulty].sentenceCount;i++){
			j=Math.floor(Math.random()*elements.length);
			element=elements[j];
			elements.splice(j,1);
			this.sentences[i]={
				"text":element.sentence.trim(),
				"start":this.sentence.length
			}
			if(element.audio_mp3 && element.audio_ogg){
				this.assets.LoadSound('sentenceAudio_'+i,element.audio_mp3,element.audio_ogg);
			}else{
				this.assets.Data.Sounds['sentenceAudio_'+i]=null;
			}
			this.sentence+=this.sentences[i].text;
		}
		this.assets.Start(this.LoadedGameSentence,this);
	}
	
	this.setCurrentSentence=setCurrentSentence;function setCurrentSentence(index){
		this.currentSentence=index;
		if(this.assets.Data.Sounds['sentenceAudio_'+index]){
			this.sentenceAudio=this.assets.Data.Sounds['sentenceAudio_'+index];
			this.playSentenceAudio=true;
		}else{
			this.sentenceAudio=null;
			this.playSentenceAudio=false;
		}
		this.hintStart=this.time-this.config.gameSettings.settings.hintDuration;
	}

	this.LoadedGameSentence=LoadedGameSentence;function LoadedGameSentence(){
		this.loadingStage=2;
		this.setCurrentSentence(0);
		this.startGame();
	}
	
	this.getHtmlSentence=getHtmlSentence;function getHtmlSentence(){
		var start,end,letter,pos;
		if(this.currentLetter>=this.sentence.length){
			start=this.sentences[this.sentences.length-1].text;
			letter=end='';
		}else{
			pos=this.currentLetter-this.sentences[this.currentSentence].start;
			start=this.sentences[this.currentSentence].text.substring(0,pos);
			letter=this.sentences[this.currentSentence].text.substring(pos,pos+1);
			end=this.sentences[this.currentSentence].text.substring(pos+1,this.sentences[this.currentSentence].text.length);
		}
		return(start+'<u id="sentenceLetter" style="color:#f00">'+letter+'</u>'+end);
	}
	
	this.startGame=startGame;function startGame(){
		this.status='lobby';
		this.trackPan=0;
		this.trackPos=0;
		this.finished=false;
		this.trackLength=this.sentence.length*this.config.gameSettings.settings.letterTrackSize;
		if(this.gameType=='single'){//setup cars for singleplayer
			this.cars=[
				new CpcPlayer(this,this.player.carType,0),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),1),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),2),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),3),
				new Cai(this,Math.floor(Math.random()*(this.config.gameSettings.cars.length-1)),4)
			];
			this.player.carID=0;
		}else{//setup cars for multiplayer
		}
		if(this.assets.Data.Sounds.raceMusic){
			this.assets.Data.Sounds.raceMusic.sound.loop=true;
			this.assets.Data.Sounds.raceMusic.Play();
		}
		//this.status='RaceReport';
	}
	
	this.lobby=lobby;function lobby(){
		var go=true;
		for(i=0;i<this.cars.length;i++){
			if(!this.cars[i].ready())go=false;
			this.cars[i].Run();
		}
		if(go){
			this.status='redlight';
			this.raceTime=this.time;
			if(this.assets.Data.Sounds.RedLight)this.assets.Data.Sounds.RedLight.Play();
		}
	}
	
	this.playing=playing;function playing(){
		this.trackPos+=5.0;
		if(this.finished)return;
		var i,finished=true,soundon;
		
		if(this.playSentenceAudio && this.sentenceAudio){
			soundon=this.soundOn;
			this.soundOn=true;
			this.sentenceAudio.Play();
			this.soundOn=soundon;
			this.playSentenceAudio=false;
		}
		
		if(this.sentenceAudio){
			if(this.sentenceAudio.sound.paused){
				if(this.assets.Data.Sounds.raceMusic && this.assets.Data.Sounds.raceMusic.sound.volume<1.0)this.assets.Data.Sounds.raceMusic.sound.volume=1.0;
				if(this.assets.Data.Sounds.RedLight && this.assets.Data.Sounds.RedLight.sound.volume<1.0)this.assets.Data.Sounds.RedLight.sound.volume=1.0;
				if(this.assets.Data.Sounds.YellowLight && this.assets.Data.Sounds.YellowLight.sound.volume<1.0)this.assets.Data.Sounds.YellowLight.sound.volume=1.0;
				if(this.assets.Data.Sounds.GreenLight && this.assets.Data.Sounds.GreenLight.sound.volume<1.0)this.assets.Data.Sounds.GreenLight.sound.volume=1.0;
			}else{
				if(this.assets.Data.Sounds.raceMusic && this.assets.Data.Sounds.raceMusic.sound.volume>0.4)this.assets.Data.Sounds.raceMusic.sound.volume=0.4;
				if(this.assets.Data.Sounds.RedLight && this.assets.Data.Sounds.RedLight.sound.volume>0.4)this.assets.Data.Sounds.RedLight.sound.volume=0.4;
				if(this.assets.Data.Sounds.YellowLight && this.assets.Data.Sounds.YellowLight.sound.volume>0.4)this.assets.Data.Sounds.YellowLight.sound.volume=0.4;
				if(this.assets.Data.Sounds.GreenLight && this.assets.Data.Sounds.GreenLight.sound.volume>0.4)this.assets.Data.Sounds.GreenLight.sound.volume=0.4;
			}
		}
		
		for(i=0;i<this.cars.length;i++){
			this.cars[i].Run();
			if(this.cars[i].type!='AI' && !this.cars[i].finished && !this.cars[i].crash){
				finished=false;
			}
		}
		if(finished && !this.finished){
			for(i=0;i<this.cars.length;i++)if(this.cars[i].type=='AI')this.cars[i].finishRace();
			if(this.assets.Data.Sounds.raceMusic)this.assets.Data.Sounds.raceMusic.Stop();
			this.finished=true;
			for(i=0;i<this.cars.length;i++)if(this.cars[i].type=='PC')break;
			var time=3000;
			if(this.cars[i].car.drawPosition<500)time+=6*(500-this.cars[i].car.drawPosition);
			setTimeout(function(){game.status='RaceReport';},time);
		}
	}
	
	this.computePoints=computePoints;function computePoints(){
		var i;
		for(i=0;i<this.cars.length;i++)this.cars[i].points=3;
	}
	
	this.keyPressed=keyPressed;function keyPressed(){
		if(game.status!='playing' && game.status!='greenlight')return;
		if(this.cars[this.player.carID].crash)return;
		if(this.cars[this.player.carID].finished)return;
		var obj=document.getElementById('raceInput');
		if(!obj)return;
		if(obj.lastSize>=obj.value.length)return;
		var keys=obj.value.substring(obj.lastSize,obj.value.length);
		obj.lastSize=obj.value.length;
		var i,key;
		for(i=0;i<keys.length;i++){
			key=keys[i];
			if(key==this.sentence.substr(this.currentLetter,1)){//correct key
				this.currentLetter++;
				this.cars[this.player.carID].position++;
				if(key==' ' || key=='.' || key==',' || key==';'){//word completed
					this.cars[this.player.carID].car.position=this.cars[this.player.carID].position*this.config.gameSettings.settings.letterTrackSize;
					this.SFX.carMoves(this.player.carID);
				}
				this.UI.setSentence('Arial',26);
				if(this.currentLetter>=this.sentence.length){//end race
					this.cars[this.player.carID].finished=true;
					if(this.assets.Data.Sounds.cheer)this.assets.Data.Sounds.cheer.Play();
					this.cars[this.player.carID].finishTime=this.time;
					this.endPos=this.trackPos;
				}
		 	}else{//wrong key
				if(this.assets.Data.Sounds.typo)this.assets.Data.Sounds.typo.Play();
				this.cars[this.player.carID].ERR++;
				if(this.cars[this.player.carID].ERR>=10){//crashing
					this.cars[this.player.carID].ERR=10;
					this.cars[this.player.carID].crash=true;
					this.cars[this.player.carID].crashTime=this.time;
					if(this.assets.Data.Sounds.crash)this.assets.Data.Sounds.crash.Play();
				}else if(this.cars[this.player.carID].ERR==6){//engine smoking
					this.SFX.addEffect('smoke_1',this.player.carID);
				}else if(this.cars[this.player.carID].ERR==8){//on fire
					this.SFX.addEffect('fire_1',this.player.carID);
				}
			}
		}
	}
	
	this.LoadGarrage=LoadGarrage;function LoadGarrage(){
		this.assets.LoadImage('garrageBG',this.homeURL+'assets/images/garrage/garagegrayBG.png');
		this.assets.LoadImage('garrageClose',this.homeURL+'assets/images/translate/'+this.language+'/garageClosed.png');
		this.assets.LoadImage('garrageHolders',this.homeURL+'assets/images/garrage/garagePlatformHolders.png');
		this.assets.LoadImage('garrageArrow',this.homeURL+'assets/images/garrage/GarageArrow.png');
		this.assets.Start(this.LoadedGarrageData,this);
	}
	
	this.LoadedGarrageData=LoadedGarrageData;function LoadedGarrageData(){
		this.status='garrage';
	}
	
	this.Run=Run;function Run(){
		var date=new Date();var Time=date.getTime();this.frameTime=Time-this.time;this.time=Time;
		if(this.gameDiv){
			cw=this.gameDiv.clientWidth;ch=this.gameDiv.clientHeight;
			if(cw/ch>960/640)cw=ch*960/640;else ch=cw*640/960;
			if(this.clientWidth!=cw || this.clientHeight!=ch){
				this.Resize(cw,ch);
			}
		}
		switch(this.status){
			case(0)://initial loading
				if(this.LoadOk())this.status='main menu';
				break;
			case('lobby'):
				this.lobby();
				break;
			case('redlight'):
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='yellowlight';if(this.assets.Data.Sounds.YellowLight)this.assets.Data.Sounds.YellowLight.Play();this.raceTime=this.time;}
				break;
			case('yellowlight'):
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='greenlight';if(this.assets.Data.Sounds.GreenLight)this.assets.Data.Sounds.GreenLight.Play();this.raceTime=this.time;this.UI.focusInput();}
				break;
			case('greenlight'):
				if(this.time-this.raceTime>this.config.gameSettings.settings.lightTimer){this.status='playing';}
			case('playing'):
				this.playing();
				break;
			default:break;
		}
		if(this.UI)this.UI.Run(this.status);
		if(this.assets){
			if(this.assets.show){
				if(this.UI)this.UI.show(false);
			}else{
				if(this.UI)this.UI.show(true);
			}
			this.assets.Run();
		}
	}
	
	function RunMain(){game.Run();}
	this.Load();
}

function CpcPlayer(game,type,lane){
	this.type='PC';
	this.car=new Ccar(game,type,lane);
	this.position=0;
	this.crash=false;
	this.finished=false;
	this.ERR=0;
	this.WPM=0;
	this.name=game.player.info.name;
	this.crashTime=0;
	this.finishTime=0;
	
	this.ready=ready;function ready(){
		this.car.goToStart();
		if(this.car.ready)return(true);
		return(false);
	}
	
	this.Run=Run;function Run(){
		if(!this.crash && !this.finished)this.WPM=(this.position*12000)/(game.time-game.raceTime);
/*		if(game.status=='playing' && this.position<game.sentence.length-1){
			this.position++;
			this.car.position=this.position*game.config.gameSettings.settings.letterTrackSize;
		}
		if(this.position>=game.sentence.length){
			this.finished=true;
			this.finishTime=this.time;
			game.endPos=game.trackPos;
		}*/
		if(this.car.position>game.trackLength)this.car.position=game.trackLength;
		this.car.Run();
		if(this.car.drawPosition>500)
			game.trackPan=this.car.drawPosition-500;
		else
			game.trackPan=0;
	}
	
	this.Draw=Draw;function Draw(){
		this.car.Draw();
	}
}

function getSearchParameters() {
      var prmstr = window.location.search.substr(1);
      return prmstr != null && prmstr != "" ? transformToAssocArray(prmstr) : {};
}

function transformToAssocArray( prmstr ) {
    var params = {};
    var prmarr = prmstr.split("&");
    for ( var i = 0; i < prmarr.length; i++) {
        var tmparr = prmarr[i].split("=");
        params[tmparr[0]] = tmparr[1];
    }
    return params;
}